# IpynbDiff: Better diff for Jupyter Notebooks

This is a simple diff tool that cleans up jupyter notebooks, transforming each [notebook](example/1/from.ipynb) 
into a [readable markdown file](example/1/from.md), keeping the output of cells, and running the
diff after. Markdowns are generated using an opinionated Jupyter to Markdown conversion. This means 
that the entire file is readble on the diff.

The result are diffs that are much easier to read:

| Diff | IpynbDiff |
| ------ | ------ |
| [Here](example/1/diff.txt) | [Here](example/1/diff_md.txt) |
| ![](img/diff.png) | ![](img/ipynbdiff.png) |


## Usage

This can be used in two ways:

### Diff script

```bash
go install  gitlab.com/gitlab-org/incubation-engineering/mlops/ipynbdiff/cmd/ipynbdiff@latest

ipynbdiff from_file to_file -context=3 -no-md
```

### As driver for GIT

```bash
go install  gitlab.com/gitlab-org/incubation-engineering/mlops/ipynbdiff/cmd/ipynbdiff-git@latest

GIT_EXTERNAL_DIFF="ipynbdiff-git" git diff fc01e7:example/1/from.ipynb fc01e7:example/1/to.ipynb
```

You can also make it global for anytime a .ipynb file is found:

```bash
git config --global diff.ipynbdiff.command ipynbdiff-git
git config --global core.attributesfile $HOME/.gitattributes
echo "*.ipynb diff=ipynbdiff" > $HOME/.gitattributes

git diff fc01e7:example/1/from.ipynb fc01e7:example/1/to.ipynb
```


### As converter

While the diff is the target of this project, the markdown converter might still be useful for
building tooling or integrating into CI/CD pipelines. Another command is provided that performs
just the conversion:

```bash
go install  gitlab.com/gitlab-org/incubation-engineering/mlops/ipynbdiff/cmd/ipynb2mdt@latest

ipynb2md -i example.ipynb
ipynb2md -i example.ipynb -o example.md
```

## Generating Examples

Examples on the `example` folder are generated by running go test:

``` bash
IPYNB_EXAMPLE=1 go test . -run TestIpynbDiff_GenerateExample
```
